<%
'*************************************************************
'* eBay Functions to list products, using XML Unified Schema
'* Copyright 2005 Sysworkers LLC 
'* coded by Ricardo Lerch ricardo[@]lerch.com.ar 
'* License information www.sysworkers.com
'*************************************************************


'***** Script variable set ***************************************
'Get your DevID, AppID, and Cert by joining at
'http://developer.ebay.com/join/
DevID = "---ENTER YOUR DevID HERE---"
AppID = "---ENTER YOUR AppID HERE---"
Cert = "---ENTER YOUR Cert HERE---"
'Create an authentication token at http://developer.ebay.com/tokentool/
AuthToken = "---ENTER YOUR TOKEN HERE---"

eBayServerURL = "https://api.ebay.com/ws/api.dll"


'Sites Ids http://developer.ebay.com/DevZone/XML/docs/WebHelp/FieldDifferences-Site_IDs.html
'http://developer.ebay.com/DevZone/XML/docs/WebHelp/WorkingWithCategories-Determining_Category_Support_for_Certain_Features.html#wp1129759
if eBaySiteID="" then eBaySiteID="0" '0=US 3=UK 186=Spain

'All (in) Return Gallery and non-Gallery item listings.  
'Gallery (in) Return Gallery items only.  
'CustomCode (out) Reserved for internal or future use.  
if eBaySearchType="" then eBaySearchType="Gallery"

'http://developer.ebay.com/DevZone/XML/docs/WSDL/xsd/1/simpletype/SearchFlagsCodeType.htm
'Charity Return only charity item listings.  
'SearchInDescription Include the description field of item listings in keyword search. Item listings returned are those where specified search keywords appear in the description, as well as the title and sub-title.  
'PayPalBuyerPaymentOption Return only item listings where PayPal is a payment method offered by the seller.  
'NowAndNew (in) Return only items that have been listed with Now and New. Applicable for certain sites only. See the Developer's Guide.  
'CustomCode (out) Reserved for internal or future use.  
if eBaySearchFlags="" then eBaySearchFlags="SearchInDescription"

'http://developer.ebay.com/DevZone/XML/docs/WSDL/xsd/1/simpletype/SearchSortOrderCodeType.htm
'SortByEndDate (in) Sort by item end date.  
'SortByStartDate (in) Sort by item start date.  
'SortByCurrentBid (in) Sort by current bid price.  
'SortByListingDate (in) Sort by listing date, descending order.  
'SortByCurrentBidAsc (in) Sort by current bid price, ascending order.  
'SortByCurrentBidDesc (in) Sort by current bid price, descending order.  
'CustomCode (out) Reserved for internal or future use.  
if eBayOrder="" then eBayOrder="SortByCurrentBidDesc"

'First page to bring default is 1 EntriesPerPage default is 100
if eBayPageNumber="" then eBayPageNumber="1"
if eBayEntriesPerPage="" then eBayEntriesPerPage="100"

'http://developer.ebay.com/DevZone/XML/docs/WSDL/xsd/1/simpletype/ItemTypeFilterCodeType.htm
'AuctionItemsOnly (in) Return auction items only.  
'FixedPricedItem (in) Return fixed price items (both Fixed Price and Buy It Now) only.  
'AllItems (in) Return all items (auction and fixed-price). 
if eBayItemTypeFilter="" then eBayItemTypeFilter="FixedPricedItem"

'ebay id category changes for each country
'http://listings.ebay.com/ http://listings.ebay.es/
if eBayCategoryID="" then eBayCategoryID="" '11233 musica instrumentos
'eBayQuery=request("q")
if eBayQuery="" and eBayCategoryID="" then eBayQuery="a"
'****************************************************************************

'script variables
if eBayItemBorderColor="" then eBayItemBorderColor="#000000"
if eBayItemBgColor="" then eBayItemBgColor="#F9F9F9"
'http://tracker.tradedoubler.com/click?p=1697&a=1119091&url=
if TradeDoublerProgramId="" then TradeDoublerProgramId="1697"
if TradeDoublerSiteId="" then TradeDoublerSiteId="1119091"
'cj.com PID is not the account number, one PID is given per website at cj.com, see PID on getLinks
if CommissionJunctionPID="" then CommissionJunctionPID="1753768"
if CommissionJunctionAID="" then CommissionJunctionPID="5463217"
if CommissionJunctionPrefix="" then CommissionJunctionPrefix="http://www.anrdoezrs.net/click-"

if eBayIntermediary="" then eBayIntermediary="CommissionJunction"

if eBayColumns="" then eBayColumns=2
if eBayMaxItems="" then eBayMaxItems=50

if eBayAdOrientation="" then eBayAdOrientation="Horizontal" 

Dim eBayReplacementsArray()


'this array is the output after procesing getsearchresults call
Dim eBayItemsArray()
Const eBayItemTitle=0
Const eBayItemSubTitle=1
Const eBayItemLink=2
Const eBayItemGalleryURL=3 'Image thumbnail
Const eBayItemCurrentPrice=4
Const eBayItemBuyItNowPrice=5
Const eBayItemBidCount=6
Const eBayItemCurrency=7
Const eBayItemStartTime=8
Const eBayItemEndTime=9
Const eBayItemListingType=10
Const eBayItemListingEnhancement=11
Const eBayItemSite=12


Dim peBayItemsPerPage
Dim peBayPageNumber
Dim peBayHasMoreItems
Dim peBayTotalNumberOfPages



Function PostXmlDocument(xd, Verb)
    Dim xt
    Set xt = CreateObject("MSXML2.ServerXMLHTTP")

    xt.open "POST", eBayServerURL, False
    xt.setRequestHeader "CONTENT-TYPE", "text/xml"
    xt.setRequestHeader "X-EBAY-API-COMPATIBILITY-LEVEL", "459" '327 341
    xt.setRequestHeader "X-EBAY-API-SESSION-CERTIFICATE", DevID & ";" & AppID & ";" & Cert
    xt.setRequestHeader "X-EBAY-API-DEV-NAME", DevID
    xt.setRequestHeader "X-EBAY-API-APP-NAME", AppID
    xt.setRequestHeader "X-EBAY-API-CERT-NAME", Cert
    xt.setRequestHeader "X-EBAY-API-CALL-NAME", Verb
    xt.setRequestHeader "X-EBAY-API-SITEID", eBaySiteID
    xt.setRequestHeader "X-EBAY-API-DETAIL-LEVEL", "0"
    
    xt.send xd
	
    If xt.Status = 200 Then
      ' Success
      Dim xdResponse ' As MSXML2.DOMDocument
      Set xdResponse = xt.responseXML
      Set PostXmlDocument = xdResponse
    Else
      Response.Write("The post failed: " & xt.Status & " " & xt.statusText)
    End If

End Function


Function BuildGetSearchResultsCall(Query)

    Dim xd ' As New MSXML2.DOMDocument
    Dim sxml 'string xml
    
	Set xd = CreateObject("MSXML2.DOMDocument")
		
	'new schema 401 http://developer.ebay.com/DevZone/migration/docs/WebHelp/wwhelp/wwhimpl/js/html/wwhelp.htm
	sxml=""	
	sxml=sxml&"<?xml version=""1.0"" encoding=""utf-8""?>"
	sxml=sxml&"<GetSearchResultsRequest xmlns=""urn:ebay:apis:eBLBaseComponents"">"
	sxml=sxml&"<RequesterCredentials>"
	sxml=sxml&"<eBayAuthToken>"&AuthToken&"</eBayAuthToken>"
	sxml=sxml&"</RequesterCredentials>"
	sxml=sxml&"<ErrorLevel>1</ErrorLevel>"
	sxml=sxml&"<DetailLevel>ReturnAll</DetailLevel>"
	sxml=sxml&"<SiteId>"&eBaySiteID&"</SiteId>"	
	sxml=sxml&"<ItemTypeFilter>"&eBayItemTypeFilter&"</ItemTypeFilter>"
	sxml=sxml&"<Pagination>"
	sxml=sxml&"<EntriesPerPage>"&eBayEntriesPerPage&"</EntriesPerPage>"
	sxml=sxml&"<PageNumber>"&eBayPageNumber&"</PageNumber>"
	sxml=sxml&"</Pagination>"
	if not eBaySearchType="" then sxml=sxml&"<SearchType>"&eBaySearchType&"</SearchType>"
	if not eBaySearchFlags="" then sxml=sxml&"<SearchFlags>"&eBaySearchFlags&"</SearchFlags>"
	if not eBayOrder="" then sxml=sxml&"<Order>"&eBayOrder&"</Order>"
	if not eBayCategoryID="" then sxml=sxml&"<CategoryID>"&eBayCategoryID&"</CategoryID>"
	if not Query="" then sxml=sxml&"<Query>"&Query&"</Query>"
	
	sxml=sxml&"</GetSearchResultsRequest>"
	
	xd.loadXML(sxml)
    
    Set BuildGetSearchResultsCall = xd

End Function


Function eBayGetSearchResults(QueryString)
  Set xdResults = PostXmlDocument(BuildGetSearchResultsCall(QueryString), "GetSearchResults")
	
  'Response.Write xdResults.text
  'xr Results item array
  Set xr = xdResults.SelectSingleNode("/GetSearchResultsResponse/SearchResultItemArray")   '/eBay/Search/Items	
  
  
  err.Clear
  on error resume next
  testObj=len(xdResults.SelectSingleNode("/GetSearchResultsResponse/SearchResultItemArray").text)
  if err.number <> 0 then
	'no results
	'Response.Write "No results" '& err.number & err.Description & err.Source
  else
	'get pagination information
	'peBayItemsPerPage=xdResults.SelectSingleNode("/GetSearchResultsResponse/ItemsPerPage").text
	'peBayPageNumber=xdResults.SelectSingleNode("/GetSearchResultsResponse/PageNumber").text
	'peBayHasMoreItems=xdResults.SelectSingleNode("/GetSearchResultsResponse/HasMoreItems").text
	'peBayTotalNumberOfPages=xdResults.SelectSingleNode("/GetSearchResultsResponse/PaginationResult/TotalNumberOfPages").text
  end if 
  err.Clear 'test token expiration field
  testObj=xdResults.SelectSingleNode("/GetSearchResultsResponse/HardExpirationWarning").text
  if err.number <> 0 then
	'token is up to date
  else
	'token is about to expire, display message to user
	'start showing message 15 days before expiration
	if datediff("d",now,cdate(testObj)) < 15 then
		Response.Write "<font color='#FF0000' size='2'><b>eBay Token expiration warning "&testObj&"</b></font>"
		'change the code here to send a silent message to the webmaster by email or any other way
	end if
  end if


  sresp=""
  itemNr=0
  reDim eBayItemsArray(xr.childNodes.length-1,12)
  For Each obj in xr.childNodes
	
	'sresp debug html code
	sresp=sresp&"<hr>"
	
	for x=0 to obj.childnodes(0).childnodes.length-1
		'ntn current NodeTagName
		ntn=obj.childnodes(0).childnodes(x).tagName
		if ntn="ListingDetails" or ntn="SellingStatus" or ntn="SiteHostedPicture" or ntn="VendorHostedPicture" or ntn="PictureDetails" then
			sresp=sresp&"<b>" & obj.childnodes(0).childnodes(x).tagName & "</b><br>"
			for y=0 to obj.childnodes(0).childnodes(x).childnodes.length-1
				sresp=sresp&" - " & obj.childnodes(0).childnodes(x).childnodes(y).tagName & " : " & obj.childnodes(0).childnodes(x).childnodes(y).text & "<br>"
				ctn=obj.childnodes(0).childnodes(x).childnodes(y).tagName
				select case ctn
					case "ViewItemURL"
						eBayItemsArray(itemNr,eBayItemLink)=obj.childnodes(0).childnodes(x).childnodes(y).text 
					case "StartTime"
						eBayItemsArray(itemNr,eBayItemStartTime)=obj.childnodes(0).childnodes(x).childnodes(y).text 
					case "EndTime"
						eBayItemsArray(itemNr,eBayItemEndTime)=obj.childnodes(0).childnodes(x).childnodes(y).text 
					case "BidCount"
						eBayItemsArray(itemNr,eBayItemBidCount)=obj.childnodes(0).childnodes(x).childnodes(y).text 
					case "CurrentPrice"
						eBayItemsArray(itemNr,eBayItemCurrentPrice)=obj.childnodes(0).childnodes(x).childnodes(y).text
					case "GalleryURL"
						eBayItemsArray(itemNr,eBayItemGalleryURL)=obj.childnodes(0).childnodes(x).childnodes(y).text
				end select
			next
			sresp=sresp&"<b>/" & obj.childnodes(0).childnodes(x).tagName & "</b><br>"
		else
			sresp=sresp&obj.childnodes(0).childnodes(x).tagName & " : " & obj.childnodes(0).childnodes(x).text & "<br>"

			select case ntn
				case "Title"
					eBayItemsArray(itemNr,eBayItemTitle)=obj.childnodes(0).childnodes(x).text 
				case "BuyItNowPrice"
					eBayItemsArray(itemNr,eBayItemBuyItNowPrice)=obj.childnodes(0).childnodes(x).text 
				case "Currency"
					eBayItemsArray(itemNr,eBayItemCurrency)=obj.childnodes(0).childnodes(x).text 
				case "SubTitle"
					eBayItemsArray(itemNr,eBayItemSubTitle)=obj.childnodes(0).childnodes(x).text
				case "Site"
					eBayItemsArray(itemNr,eBayItemSite)=obj.childnodes(0).childnodes(x).text
				case "ListingType"
					eBayItemsArray(itemNr,eBayItemListingType)=obj.childnodes(0).childnodes(x).text 
				case "ListingEnhancement"
					eBayItemsArray(itemNr,eBayItemListingEnhancement)=obj.childnodes(0).childnodes(x).text 
			end select
		end if
	next
	sresp=sresp&"<hr>"
	itemNr=itemNr+1
    Next
	
	'return 0 if success
	eBayGetSearchResults=err.number

End Function

Function BuildGeteBayDetailsCall()

    Dim xd ' As New MSXML2.DOMDocument
    Dim sxml 'string xml
    
	Set xd = CreateObject("MSXML2.DOMDocument")
		
	sxml=""	
	sxml=sxml&"<?xml version=""1.0"" encoding=""utf-8""?>"
	sxml=sxml&"<GeteBayDetailsRequest xmlns=""urn:ebay:apis:eBLBaseComponents"">"
	sxml=sxml&"<Version>459</Version>" '423
	sxml=sxml&"<RequesterCredentials>"
	sxml=sxml&"<eBayAuthToken>"&AuthToken&"</eBayAuthToken>"
	sxml=sxml&"</RequesterCredentials>"
	sxml=sxml&"<DetailName>URLDetails</DetailName>"
	sxml=sxml&"</GeteBayDetailsRequest>"
	
	xd.loadXML(sxml)
    
    Set BuildGeteBayDetailsCall = xd

End Function

Function eBayGetLogoURL()
	Set xdResults = PostXmlDocument(BuildGeteBayDetailsCall(), "GeteBayDetails")
	Set xr = xdResults.SelectSingleNode("/")
	For Each obj in xr.childNodes
		for x=0 to obj.childnodes.length-1
			if obj.childnodes(x).tagname = "URLDetails" then
				'SmallLogoURL MediumLogoURL LargeLogoURL ViewItemURL ViewUserURL MyeBayURL MyeBayBiddingURL MyeBayNotWonURL MyeBayWonURL MyeBayWatchingURL eBayStoreURL 
				pURLType="SmallLogoURL"
				if pURLType=obj.childnodes(x).SelectSingleNode("URLType").text then
					pLogoURL=obj.childnodes(x).SelectSingleNode("URL").text
				end if
			end if
		next
	next
	'Response.Write pLogoURL
	eBayGetLogoURL=pLogoURL
End Function


Function eBayUpdateLogo()
	'Uses XML component and filesystem object
	'request logo file via http and saves to the local server, if not exist or out of date
	on error resume next
	Set fs=Server.CreateObject("Scripting.FileSystemObject")
	Set f=fs.GetFile(server.MapPath("/images/")&"\ebaylogo"&eBaySiteID&".gif")
	if datepart("d",f.DateCreated)<>datepart("d",now) or err<>0 then
		set xml = Server.CreateObject("Microsoft.XMLHTTP")
		xml.open "GET", eBayGetLogoURL, false
		xml.send
		SaveBinaryData server.MapPath("/images/")&"\ebaylogo"&eBaySiteID&".gif",xml.responseBody
	end if
End Function


Function SaveBinaryData(FileName, ByteArray) 
	Const adTypeBinary = 1 
	Const adSaveCreateOverWrite = 2 
	'Create Stream object 
	Dim BinaryStream 
	Set BinaryStream = CreateObject("ADODB.Stream") 
	'Specify stream type - we want To save binary data. 
	BinaryStream.Type = adTypeBinary 
	'Open the stream And write binary data To the object 
	BinaryStream.Open 
	BinaryStream.Write ByteArray 
	'Save binary data To disk 
	BinaryStream.SaveToFile FileName, adSaveCreateOverWrite 
End Function 


Function eBayDisplayItems()
	on error resume next
	
	eBayUpdateLogo
	if len(eBayQuery)>0 then
		eBayGetSearchResults(eBayQuery) 
	end if

	'trade doubler url for componemos.com
	'http://tracker.tradedoubler.com/click?p=1697&a=1119091&url=
	err.Clear
	
	'process the entire array
	
	n=LBound(eBayItemsArray)
	
	if err.number=0 then
		
		if eBayIntermediary="TradeDoubler" then
			'generates link for trade doubler
			strLink="http://tracker.tradedoubler.com/click?p="&TradeDoublerProgramId&"&a="&TradeDoublerSiteId&"&url=http://www.ebay.com/api/index.html"
		else		
			'generates link for commissionjunction cj.com
			strLink=CommissionJunctionPrefix&CommissionJunctionPID&"-"&CommissionJunctionAID&"?loc="&server.URLEncode("http://www.ebay.com/api/index.html")
		end if
				
		'generates redirect link
		'strLink="/goto.asp?u="&server.URLEncode(strLink)
		
		Response.Write "<table border='0' width='100%' cellspacing='0'><tr><td colspan="&eBayColumns&"><a href='"&strLink&"'><img border=0 src='/images/ebaylogo"&eBaySiteID&".gif'></a><br></tr><tr>"
	
		DisplayedItems=0
		for n=LBound(eBayItemsArray) to UBound(eBayItemsArray)
			
			eBayMaxItems=cint(eBayMaxItems)
			doDisplayItem=1
			if n>0 then
				'if same title then do not Display, remove duplicates titles
				if eBayItemsArray(n,eBayItemTitle)=eBayItemsArray(n-1,eBayItemTitle) or DisplayedItems=>eBayMaxItems then
					doDisplayItem=0
				end if				
			end if
			
			if doDisplayItem=1 then
				
				if DisplayedItems>0 and (DisplayedItems)/eBayColumns=int((DisplayedItems)/eBayColumns) then Response.Write "</tr><tr>"	
			
				'choose fixed price
				if not eBayItemsArray(n,eBayItemBuyItNowPrice)="" then
					strPrice=eBayItemsArray(n,eBayItemBuyItNowPrice)
				else
					strPrice=eBayItemsArray(n,eBayItemCurrentPrice)
				end if
				strimg=eBayItemsArray(n,eBayItemGalleryURL)
				if len(strimg)=0 then strimg="/images/ebayRepLogo.gif"
			    
			    if eBayIntermediary="TradeDoubler" then
					'generates link for trade doubler
					strLink="http://tracker.tradedoubler.com/click?p="&TradeDoublerProgramId&"&a="&TradeDoublerSiteId&"&url="&eBayItemsArray(n,eBayItemLink)
				else	
					'generates link for commissionjunction cj.com
					strLink=CommissionJunctionPrefix&CommissionJunctionPID&"-"&CommissionJunctionAID&"?loc="&server.URLEncode(eBayItemsArray(n,eBayItemLink))
				end if
				
				'generates redirect link
				'strLink="/goto.asp?u="&server.URLEncode(strLink)				
	
				
				'write HTML output
				if eBayAdOrientation="Vertical" then
					Response.Write "<td valign='top'><table border='1' width='100%' bordercolor='#FFFFFF' bordercolordark='#FFFFFF' bordercolorlight='"&eBayItemBorderColor&"' cellspacing='0'>"
					Response.Write "<tr><td align='center' bgcolor='#FFFFFF'><a href='"&strLink&"'><img border='0' src='"&strimg&"'></a></td></tr>"
					Response.Write "<tr><td bgcolor='"&eBayItemBgColor&"'><b><a href='"&strLink&"'>"&eBayItemsArray(n,eBayItemTitle)&"</a></b><br>"&"<br><b>"&eBayItemsArray(n,eBayItemCurrency)&" "&strPrice&"</b></td></tr>"
					Response.Write "</table></td>"
				else
					Response.Write "<td><table border='1' width='100%' bordercolor='#FFFFFF' bordercolordark='#FFFFFF' bordercolorlight='"&eBayItemBorderColor&"' cellspacing='0'>"
					Response.Write "<tr><td align='center' width='100' height='100' bgcolor='#FFFFFF'><a href='"&strLink&"'><img border='0' src='"&strimg&"'></a></td>"
					Response.Write "<td bgcolor='"&eBayItemBgColor&"'><b><a href='"&strLink&"'>"&eBayItemsArray(n,eBayItemTitle)&"</a></b><br>"&"<br><b>"&eBayItemsArray(n,eBayItemCurrency)&" "&strPrice&"</b></td></tr>"
					Response.Write "</table></td>"
				end if

				DisplayedItems=DisplayedItems+1
			
			end if
			
		next
		
		Response.Write "</tr></table>"
		'if remove the following line make sure to place it somewhere else in the website
		Response.Write "<font size='2'>Designated trademarks and brands are the property of their respective owners</font><br>"
		Response.Write "<font size='2'><a href='http://www.sysworkers.com' title='beListings Free ebay affiliate software'>beListings Free ebay software</a></font>"
	   
		'Pagination information
		'Use pagination informaiton for future calls
		'Response.write "<br>ItemsPerPage "& peBayItemsPerPage
		'Response.write "<br>PageNumber "& peBayPageNumber
		'Response.write "<br>HasMoreItems "& peBayHasMoreItems
		'Response.write "<br>TotalNumberOfPages "& peBayTotalNumberOfPages
		
	 else
	  'no items
	 end if
End Function

%>

